<script lang="ts">
import Vue from 'vue';
import CodeEditor from '../solutions/code-suggestions/code-editor/index.vue';

export default Vue.extend({
  name: 'TabbedFeatures',
  components: {
    CodeEditor,
  },
  props: {
    data: {
      type: Object,
      required: true,
      default() {
        return {};
      },
    },
    codeBlocks: {
      type: Object,
      required: false,
      default: null,
    },
  },
  data() {
    return {
      tabs: [],
      firstTab: null,
      lastTab: null,
      tabpanels: [],
      selectedTab: 0,
    };
  },
  methods: {
    onTabChange(value: number) {
      this.selectedTab = value;
    },
    getCodeblocks(block) {
      return block ?? this.codeBlocks;
    },
  },
});
</script>

<template>
  <section class="tabbed-features">
    <SlpContainer>
      <div class="tabbed-features__wrapper">
        <div class="tabbed-features__header">
          <SlpTypography variant="heading4-bold" tag="h2">
            {{ data.header }}
          </SlpTypography>
        </div>
        <SlpTypography
          variant="heading2-bold"
          tag="p"
          class="slp-mt-16 tabbed-features__blurb"
        >
          {{ data.blurb }}
        </SlpTypography>

        <div
          class="tabbed-features__tabs"
          role="tablist"
          aria-labelledby="tablist-1"
        >
          <button
            v-for="(tab, tabIndex) in data.tabs"
            :id="`tab-${tabIndex}`"
            :key="tab.header"
            ref="tab"
            type="button"
            role="tab"
            aria-selected="true"
            :aria-controls="`tabpanel-${tabIndex}`"
            class="tabbed-features__tab"
            :class="
              selectedTab == tabIndex ? 'tabbed-features__tab--active' : ''
            "
            :data-ga-name="tab.data_ga_name"
            :data-ga-location="tab.data_ga_location"
            @click="onTabChange(tabIndex)"
          >
            <SlpTypography variant="heading5-bold" tag="span">
              <span class="tabbed-features__header-desktop"
                >{{ tab.header }}
              </span>
              <span class="tabbed-features__header-mobile">
                {{ tab.header_mobile }}
              </span>
            </SlpTypography>
          </button>
        </div>

        <div
          v-for="(tabContent, tabContentIndex) in data.tabs"
          v-show="tabContentIndex === selectedTab"
          :id="`tabpanel-${tabContentIndex}`"
          :key="`tab-content-${tabContentIndex}`"
          role="tabpanel"
          tabindex="0"
          :aria-labelledby="`tab-${tabContentIndex}`"
          class="tabbed-features__content"
          :class="
            selectedTab == tabContentIndex
              ? 'tabbed-features__content--active'
              : ''
          "
        >
          <SlpRow class="tabbed-features__row">
            <SlpColumn :col="6" class="tabbed-features__col">
              <SlpTypography
                variant="body2-bold"
                tag="p"
                class="slp-mb-8 tabbed-features__feature-header"
              >
                {{ tabContent.header }}
              </SlpTypography>
              <SlpTypography variant="heading5" tag="p" class="slp-mb-48">
                {{ tabContent.blurb }}
              </SlpTypography>
              <ul>
                <li
                  v-for="feature in tabContent.features"
                  :key="feature.text"
                  class="tabbed-features__feature"
                >
                  <SlpIcon
                    v-if="feature.icon?.name"
                    :name="feature.icon.name"
                    :variant="feature.icon.variant"
                    :size="feature.icon.size"
                    slp-color="accent-400"
                    class="slp-mr-16 tabbed-features__button-icon"
                    :class="{
                      'tabbed-features__icon-stroke':
                        feature.icon.name == 'clipboard-check-alt',
                    }"
                  />
                  <SlpButton
                    variant="tertiary"
                    :href="feature.href"
                    class="tabbed-features__feature__button"
                    :data-ga-name="feature.data_ga_name"
                    :data-ga-location="feature.data_ga_location"
                  >
                    {{ feature.text }}
                    <SlpIcon
                      name="arrow-right"
                      variant="product"
                      size="medium"
                      class="hero-scroll-gallery__content-icon"
                    />
                  </SlpButton>
                </li>
              </ul>
            </SlpColumn>
            <SlpColumn
              :col="6"
              class="tabbed-features__col tabbed-features__col--media"
            >
              <div
                v-if="tabContent.image"
                class="tabbed-features__img-container"
              >
                <img
                  :src="tabContent.image.src"
                  :alt="tabContent.image.text"
                  loading="lazy"
                />
              </div>

              <CodeEditor
                v-else-if="tabContent.code_blocks || codeBlocks"
                :code-blocks="getCodeblocks(tabContent.code_blocks)"
                :ga-data="tabContent.data_ga_location"
              />
            </SlpColumn>
          </SlpRow>
        </div>
      </div>
    </SlpContainer>
  </section>
</template>

<style lang="scss" scoped>
.tabbed-features {
  background: $color-surface-700;
  color: $color-surface-50;
  padding: $spacing-64 0 $spacing-32 0;
  @media (min-width: $breakpoint-sm) {
    padding: $spacing-48 0 $spacing-64 0;
  }
  @media (min-width: $breakpoint-md) {
    padding: $spacing-96 0 $spacing-64 0;
  }
  &__header {
    max-width: 480px;
    background: linear-gradient(
      91.08deg,
      #feb484 1.97%,
      #a686f2 27.88%,
      #592ac8 65.98%
    );
    background-clip: text;
    -webkit-background-clip: text;
    -webkit-text-fill-color: transparent;
  }
  &__tabs {
    padding: $spacing-64 0 $spacing-32 0;
    display: flex;
    @media (min-width: $breakpoint-md) {
      display: block;
      padding: $spacing-64 0;
    }
  }
  &__tab {
    background: $color-surface-600;
    border-radius: 90px;
    border: none;
    color: $color-surface-50;
    margin-right: $spacing-8;
    padding: $spacing-8 $spacing-24;
    margin-bottom: $spacing-16;
    transition: all 0.3s ease;
    cursor: pointer;
    flex: 1 1 100%;
    @media (min-width: $breakpoint-md) {
      margin-right: $spacing-24;
    }
    &:hover,
    &:focus,
    &:active,
    &--active {
      background: $color-accent-500;
    }
    @media (min-width: $breakpoint-md) {
      margin-bottom: 0;
    }
  }
  &__header-desktop {
    display: none;
    @media (min-width: $breakpoint-md) {
      display: block;
    }
  }
  &__header-mobile {
    display: block;
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }
  &__feature-header {
    display: block;
    color: $color-accent-400;
    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }
  &__content {
    opacity: 0;
    img {
      width: 100%;
    }
    &--active {
      animation: fade-in 0.3s linear forwards 0.1s;
    }
  }
  &__feature {
    color: $color-surface-50;
    display: flex;
    align-items: center;
    margin-bottom: $spacing-32;
    &__button {
      color: $color-surface-50;
      display: inline-block;
      text-align: left;
      :deep {
        .slp-icon {
          display: inline-flex;
          align-items: center;
          margin-left: 3px;
          width: 16px;
          height: 16px;
          position: relative;
          top: 2px;
          div {
            position: absolute;
            display: inline-flex;
            align-items: center;
            margin-bottom: -2px;
          }
        }
      }
    }
  }
  &__button-icon {
    color: $color-accent-400;
  }
  &__icon-stroke {
    stroke: currentColor;

    :deep path {
      stroke: currentColor;
    }
  }
  &__blurb {
    max-width: 800px;
  }
  &__row {
    margin-left: -32px;
  }

  &__col {
    padding-left: 32px;
    &--media {
      :deep .container {
        margin-bottom: 0;
      }
    }
  }

  @keyframes fade-in {
    from {
      opacity: 0;
      transform: translateY(10px);
    }
    to {
      opacity: 1;
      transform: translateY(0);
    }
  }

  &__img-container {
    line-height: 0;
  }
}
</style>
